      PROGRAM CHECK_OUT
      INTEGER, PARAMETER:: N_ZEN=18, N_AZ=37
      INTEGER  I, J, K, UNIT, N_SCE, NS_OUT, N1, N2, shi_zen, shi_az, ia
      CHARACTER (LEN=80)  DIR, N_MYS, N_SCI_D, N_SCI_U
      CHARACTER (LEN=1)   SCO(4)
      REAL*8   DUM(10), Zn(4), D_My(4), D_MySc(4),  HEL(4), D_v359(4), 
     $     D_MyIp(4), D_MyPs(4), Rdif
      REAL*8, ALLOCATABLE:: S_MYS(:,:), S_SCI(:,:), DD(:,:), DR(:,:)

      SCO(1) = 'I' ; SCO(2) = 'Q' ; SCO(3) = 'U' ; SCO(4) = 'V'
      NS_OUT = 4
      UNIT = 23
      DIR = './'
      Zn(1:2) = 1.d0 ; Zn(3:4) = -1.d0
      N1 = 7 ; N2 = 10
      N_MYS   = './B3/iprt_case_b3_mystic_0-30.dat'
      N_SCI_D = './B3/DATA_OUT/intensity-dn.dat'
      N_SCI_U = './B3/DATA_OUT/intensity-up.dat'
c     ... Previous results after comparisons with IPOL and Pstar
      D_MyIp(1) =  0.060;   D_MyPs(1) = 0.154
      D_MyIp(2) =  0.049;   D_MyPs(2) = 0.052
      D_MyIp(3) =  0.043;   D_MyPs(3) = 0.047
      D_MyIp(4) =  1.489;   D_MyPs(4) = 1.553

      OPEN( UNIT, FILE='./B3/SCIA-3.5.9.dat', STATUS='OLD' )
        READ(UNIT,*) 
        DO I = 1,NS_OUT
           READ(UNIT,*) D_v359(I)
        ENDDO
      CLOSE( UNIT )

c     ... Number of scenario in MYSTIC file
      N_SCE = N_ZEN*N_AZ*2
      ALLOCATE( S_MYS(4,N_SCE), S_SCI(4,N_SCE), DD(4,N_ZEN*N_AZ), 
     $     DR(4,N_ZEN*N_AZ) )
c     ... Reading MYSTIC results
      OPEN( UNIT, FILE=TRIM(N_MYS), STATUS='OLD' )
      DO I = 1,3 ; READ(UNIT,*) ; ENDDO
      DO I = 1,N_SCE
         READ(UNIT,*) (DUM(J),J=1,10)
         S_MYS(1:4,I) = DUM(N1:N2)
      ENDDO
      CLOSE( UNIT )

c     ------------------------------------------------------------------
c     ... Reading SCIATRAN results (downwards radiation)
      OPEN( UNIT, FILE=TRIM(N_SCI_D), STATUS='OLD' )
      DO I = 1,3 ; READ(UNIT,*) ; ENDDO
      DO I = 1, N_ZEN*N_AZ
         READ(UNIT,*) (DUM(J),J=1,6)
         DR(1:4,I) = DUM(3:6)
      ENDDO
      CLOSE( UNIT )
c     ... Change sequence in SCIATRAN output   
                  DO ia = 1,n_az
                     shi_zen = (ia-1)*n_zen
                     DO i = 1, n_zen
                        shi_az = (i-1)*n_az
                        DO k = 1,4 
                           DD(k,shi_zen + i) = DR(k,shi_az + ia)
                        ENDDO
                     ENDDO
                  ENDDO
      S_SCI(1:4,1:N_ZEN*N_AZ) = DD(1:4,:)
c     ... Reading SCIATRAN results (upwards radiation)
      OPEN( UNIT, FILE=TRIM(N_SCI_U), STATUS='OLD' )
      DO I = 1,3 ; READ(UNIT,*) ; ENDDO
      DO I = 1, N_ZEN*N_AZ
         READ(UNIT,*) (DUM(J),J=1,6)
         DR(1:4,I) = DUM(3:6)
      ENDDO
      CLOSE( UNIT )
c     ... Change sequence in SCIATRAN output   
                   DO ia = 1,n_az
                      shi_zen = (ia-1)*n_zen
                      DO i = 1, n_zen
                         shi_az = (i-1)*n_az
                         DO k = 1,4 
                            DD(k,shi_zen + i) = DR(k,shi_az + ia)
                         ENDDO
                      ENDDO
                   ENDDO
      S_SCI(1:4,N_ZEN*N_AZ+1:N_SCE) = DD(1:4,:)
     
c     ------------------------------------------------------------------
c     ... Mean root square between MYSTIC and SCIATRAN
      DO I = 1,4
         D_MySc(I) = DSQRT( SUM( (S_MYS(I,:)-Zn(I)*S_SCI(I,:))**2 ) )
         D_My  (I) = DSQRT( SUM( S_MYS(I,:)**2 ) )
      ENDDO

      WRITE(*,'(5x,A)') 'Comparison results of test B3'
      WRITE(*,'(5x,A)') 
     $  ' -  Aerosol profile and standard atmosphere'
      WRITE(*,'(5x,A,3x,A,5x,A,3x,A)') 
     $     'SCIATRAN','IPOL','PSTAR','V-3.5.9'
      HEL(1:NS_OUT) = D_MySc(1:NS_OUT)/D_My(1:NS_OUT)*100.
      DO I = 1,NS_OUT
         WRITE(*,'(2x,A,4(2x,F7.4))') 
     $        SCO(I), HEL(I), D_MyIp(I), D_MyPs(I), D_v359(I)
      ENDDO

      Rdif = MAXVAL( 
     $     DABS( HEL(1:NS_OUT)-D_v359(1:NS_OUT) )/HEL(1:NS_OUT)*100. ) 
      IF( Rdif <= 0.1d0 ) THEN
         WRITE(*,'(A)') 
     $        '   ***** Comparison is successful *****'
      ELSE
         WRITE(*,'(A,2x,e12.4,2x,A)')
     $        '  Maximal difference between 3.5.9 and current version:',
     $        Rdif,' %'
      ENDIF

c      OPEN( UNIT, FILE='./B3/SCIA-3.5.9.dat', STATUS='NEW' )
c        WRITE( UNIT,'(A)')'# Results of SCIATRAN version 3.5.9 '
c        DO I = 1,NS_OUT
c           WRITE(UNIT,'(2x,E15.7)') D_MySc(I)/D_My(I)*100.
c        ENDDO
c      CLOSE( UNIT )

      END
