#!/usr/bin/perl
package MainIPRT;
use vars qw(@ISA @EXPORT);
require Exporter;
@ISA = qw(Exporter);

our @EXPORT = qw(MainInit InitA InitB);

sub MainInit {
undef @contents;
push @contents, 'Screen output';
push @contents, "S, N, S \n";
#push @contents, "S, S, S \n";
push @contents, 'Output directory';
push @contents, "./DATA_OUT \n";
push @contents, 'Surface reflection type';
push @contents, "alb_const \n";
push @contents, 'RTM Mode';
push @contents, "int \n";
push @contents, 'RTM-CORE';
push @contents, "DOM_V \n";
push @contents, 'Include radiative transfer within ocean or ice';
push @contents, "none \n";
push @contents, 'Include land fluorescence';
push @contents, "off \n";
push @contents, 'Extra-terrestrial solar flux';
push @contents, "Unity \n";
push @contents, 'Spectral segment info';
push @contents, "1,'nm'";
push @contents, "1, 500., 1, 0.1 \n";
push @contents, 'Wavelength grid from file';
push @contents, "f \n";
push @contents, 'Forward model: trace gases';
push @contents, "none \n";
push @contents, 'Line absorber treatment';
push @contents, "off \n";
push @contents, 'Do convolution';
push @contents, "f \n";
push @contents, 'Thermal emission';
push @contents, "f \n";
push @contents, 'Advanced Rayleigh settings';
push @contents, "t \n";
push @contents, 'Aerosol settings';
push @contents, "off \n";
push @contents, 'Clouds present?';
push @contents, "f \n";
push @contents, 'Height above sea level';
push @contents, "0 \n";
push @contents, 'Advanced profile settings';
push @contents, "f \n";
push @contents, 'Photochemical calculations';
push @contents, "f \n";
push @contents, 'Advanced accuracy control';
push @contents, "t \n";
push @contents, 'Output format specification';
push @contents, "t \n";
push @contents, 'Standard profile scenario file name';
push @contents, "'mon04lat45n.b2d' \n";
push @contents, 'Scattering mode';
push @contents, "ms \n";
push @contents, 'SS/MS wavelength boundary';
push @contents, "300. \n";
push @contents, 'Adaptive grid';
push @contents, "off \n";
push @contents, 'Adaptive grid (aerosol, cloud)';
push @contents, "f \n";
push @contents, 'Azimuth series flag';
push @contents, "t \n";
push @contents, 'Accuracy criterion';
push @contents, "0.001 \n";
push @contents, 'Post-processing type';
push @contents, "Int_SF \n";
push @contents, 'Single scattering correction';
push @contents, "t \n";
push @contents, 'Analytic for conservative scattering';
push @contents, "t  1.d-7 \n";
push @contents, 'Integration over L-of-S in Fourier space?';
push @contents, "yes \n";
push @contents, 'Output of following Stokes components';
push @contents, "1  4 \n";
push @contents, 'Output of ellipsometric parameters';
push @contents, "no \n";
push @contents, 'Fluxes for path representation';
push @contents, "no \n";
push @contents, 'Output of surface albedo';
push @contents, "no \n";
push @contents, 'Transform to reflection function?';
push @contents, "f \n";
push @contents, 'Write local optical parameters';
push @contents, "f \n";
push @contents, 'Intensity representation in output file';
push @contents, "dynamic \n";
push @contents, 'Intensity or Stokes vector output format';
push @contents, "default \n";
push @contents, 'Rayleigh scattering scaling';
push @contents, "f \n";
push @contents, 'Wavelength grid for Rayleigh scattering output';
push @contents, "500 \n";
push @contents, 'Rayleigh scattering index';
push @contents, "4 \n";
push @contents, 'King factor';
push @contents, "constant \n";
push @contents, 'Rayleigh depolarisation value';
push @contents, "0.03 \n";
push @contents, 'Position to define geometry';
push @contents, "inst \n";
push @contents, 'Type of LOS definition';
push @contents, "va \n";
push @contents, 'Angle selection mode';
push @contents, "all \n";

return @contents;
}

sub InitA{
undef @contents;
push @contents, 'Perform IPRT comparison';
push @contents, "t f \n";
push @contents, 'Altitude grid';
push @contents, "0.0 1.0\n";
push @contents, 'Rayleigh optical thickness';
push @contents, "t   0.1\n";
# VHL Settings
push @contents, 'Directory name for input files';
push @contents, "'./' \n";
push @contents, 'Scattering function representation (VHL)';
push @contents, "Expansion_coeff \n";
push @contents, 'Asymmetry factor value';
push @contents, "0.7 \n";
push @contents, 'File name containing scattering function/matrix';
push @contents, "'Scatt_func.out'\n";

return @contents;
}

sub InitB{
undef @contents;
push @contents, 'Perform IPRT comparison';
push @contents, "t t \n";
push @contents, 'RTM_TYPE';
push @contents, "pp_scat \n";
push @contents, 'Altitude grid';
push @contents, "0.0 30.0";
push @contents, "1.0\n";
push @contents, 'Rayleigh optical thickness';
push @contents, "f   0.1\n";
push @contents, 'Albedo';
push @contents, "0.0 \n";

return @contents;
}
