#!/usr/bin/perl
use lib ("./");
use MainIPRT;

$prog=$ARGV[0];
$n_exe=$ARGV[1];
$dir = './A5';
#      This test requires 7 - 8 minutes computer time
# -----------------------------------------------------------------------
$name="$dir/my_init.inp";

@MainArr = MainInit();
@AddArr = InitA();

#     Specific settings
push @LocArr, 'Number of streams';
push @LocArr, "128 \n";
push @LocArr, 'Number of Legendre moments';
push @LocArr, "256 \n";
push @LocArr, 'RTM_TYPE';
push @LocArr, "vhl \n";
push @LocArr, 'Albedo';
push @LocArr, "0.0 \n";
push @LocArr, 'File name containing expansion coefficient (VHL)';
push @LocArr, "'xk_a5.txt'\n";
push @LocArr, 'Optical thickness (VHL)';
push @LocArr, "5\n";
push @LocArr, 'Single scattering albedo (VHL)';
push @LocArr, "0.999979\n";

#     Specific geometry settings
push @LocArr, 'Solar zenith angles';
push @LocArr, "50 \n";
push @LocArr, 'Azimuth angles';
push @LocArr, "0.0, 180.0 \n";

#
# ------------ Setting  for upward radiation -----------------
push @ViewDir, 'Position of the instrument';
push @ViewDir, "toa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "80., 79., 78., 77., 76., 75., 74., 73., 72., 71., 70., 69., 68., 67., 66., 65., 64., 63., 62., 61., 60., 59., 58., 57., 56., 55., 54., 53., 52., 51., 50., 49., 48., 47., 46., 45., 44., 43., 42., 41., 40., 39., 38., 37., 36., 35., 34., 33., 32., 31., 30., 29., 28., 27., 26., 25., 24., 23., 22., 21., 20., 19., 18., 17., 16., 15., 14., 13., 12., 11., 10., 9., 8., 7., 6., 5., 4., 3., 2., 1., 0. \n";

push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

# -----------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-up.dat'");

#
# ------------ Settings  for downward radiation -----------------
undef @ViewDir;
push @ViewDir, 'Position of the instrument';
push @ViewDir, "boa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "100., 101., 102., 103., 104., 105., 106., 107., 108., 109., 110., 111., 112., 113., 114., 115., 116., 117., 118., 119., 120., 121., 122., 123., 124., 125., 126., 127., 128., 129., 130., 131., 132., 133., 134., 135., 136., 137., 138., 139., 140., 141., 142., 143., 144., 145., 146., 147., 148., 149., 150., 151., 152., 153., 154., 155., 156., 157., 158., 159., 160., 161., 162., 163., 164., 165., 166., 167., 168., 169., 170., 171., 172., 173., 174., 175., 176., 177., 178., 179.,  180. \n";

# ------------ Writing my_init.inp -----------------
undef @contents;
push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

#       Perform SCIATRAN calculation for downward radiation
# ----------------------------------------------------------
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-dn.dat'");
system("$dir/'check_out.exe'");

exit 0;
