#!/usr/bin/perl
$prog=$ARGV[0];
$n_exe=$ARGV[1];
$dir = './A5';
#      This test requires 7 - 8 minutes computer time
# -----------------------------------------------------------------------------------
#  Set "control.inp"
$file="$prog/'control.inp'";
$name="$dir/'control.inp'";
system("cp $file 'control.inp'");
#     Specific settings
&set_parameter_mult('control.inp', 'Screen output', 1, 'S, N, S ', 'F', 0); 
&set_parameter_mult('control.inp', 'Perform IPRT comparison',  1, ' t   f', 'F', 0); 
&set_parameter_mult('control.inp', 'RTM_TYPE',                 1, 'vhl',       'F', 0); 
&set_parameter_mult('control.inp', 'Surface reflection type',  1, 'alb_const', 'F', 0);
&set_parameter_mult('control.inp', 'Albedo',                   1, '0.0',       'F', 0);
#     General settings
&set_parameter_mult('control.inp', 'RTM Mode', 1, 'int', 'F', 0); 
&set_parameter_mult('control.inp', 'RTM-CORE', 1, 'DOM_V', 'F', 0); 
&set_parameter_mult('control.inp', 'Include radiative transfer within ocean or ice', 
		    1, 'none', 'F', 0); 
#&set_parameter_mult('control.inp', 'Include land fluorescence',    1, 'f', 'F', 0); 
&set_parameter_mult('control.inp', 'Include land fluorescence',    1, 'off', 'F', 0); 
&set_parameter_mult('control.inp', 'Include land fluorescence',    2, './none', 'T', 0); 
&set_parameter_mult('control.inp', 'Include land fluorescence',    3, '1.', 'F', 0); 
&set_parameter_mult('control.inp', 'Extra-terrestrial solar flux', 1, 'Unity', 'F', 0); 
&set_parameter_mult('control.inp', 'Spectral segment info',        1, '1', 'F', 0); 
&set_parameter_mult('control.inp', 'Spectral segment info',        2, 'nm', 'T', 0); 
@inv = ('1', '500.', '1', '0.1');
$ii = 1;
foreach $entry (@inv){
#    print "$ii";
    &set_parameter_mult('control.inp', 'Spectral segment info', $ii, $entry, 'F', 1); 
    ++$ii;
}
&set_parameter_mult('control.inp', 'Wavelength grid from file',  1, 'f', 'F', 0); 
&set_parameter_mult('control.inp', 'Forward model: trace gases', 1, 'none', 'F', 0); 
&set_parameter_mult('control.inp', 'Line absorber treatment',    1, 'off', 'F', 0); 
&set_parameter_mult('control.inp', 'Do convolution',             1, 'f', 'F', 0); 
&set_parameter_mult('control.inp', 'Thermal emission',           1, 'f', 'F', 0); 
&set_parameter_mult('control.inp', 'Advanced Rayleigh settings', 1, 't', 'F', 0); 
&set_parameter_mult('control.inp', 'Aerosol settings',           1, 'off', 'F', 0); 
&set_parameter_mult('control.inp', 'Clouds present?',            1, 'f', 'F', 0);
&set_parameter_mult('control.inp', 'Altitude grid file name',    1, 'NET_1L.DAT', 'T', 0);
&set_parameter_mult('control.inp', 'Height above sea level',     1, '0.', 'F', 0);
&set_parameter_mult('control.inp', 'Advanced profile settings',  1, 'f' , 'F', 0);
&set_parameter_mult('control.inp', 'Photochemical calculations', 1, 'f' , 'F', 0);
&set_parameter_mult('control.inp', 'Advanced accuracy control',  1, 't' , 'F', 0);
&set_parameter_mult('control.inp', 'Output format specification',1, 't' , 'F', 0);
&set_parameter_mult('control.inp', 'Standard profile scenario file name',
		    1, 'mon04lat45n.b2d','T',0);
system("mv 'control.inp' $name");
#
# -----------------------------------------------------------------------------------
#  Set "control_ac.inp"
$file="$prog/'control_ac.inp'";
$name="$dir/'control_ac.inp'";
system("cp $file 'control_ac.inp'");
#     Specific settings
&set_parameter_mult('control_ac.inp', 'Number of streams',          1, '128', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Number of Legendre moments', 1, '256', 'F', 0); 
#     General settings
&set_parameter_mult('control_ac.inp', 'Scattering mode',           1, 'ms', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'SS/MS wavelength boundary', 1, '300.', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Adaptive grid',             1, 'off', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Adaptive grid (aerosol, cloud)', 1, 'f', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Azimuth series flag',       1, 't', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Accuracy criterion',        1, '0.001', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Post-processing type',      1, 'Int_SF', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Single scattering correction', 1, 't', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Analytic for conservative scattering', 
		    1, 't  1.d-7', 'F', 0); 
&set_parameter_mult('control_ac.inp', 'Integration over L-of-S in Fourier space?', 
		    1, 'yes', 'F', 0); 
system("mv 'control_ac.inp' $name");
#
# -----------------------------------------------------------------------------------
#  Set "control_out.inp"
$file="$prog/'control_out.inp'";
$name="$dir/'control_out.inp'";
system("cp $file 'control_out.inp'");
&set_parameter_mult('control_out.inp', 'Output of following Stokes components', 
		    1, '1  4', 'F', 0); 
&set_parameter_mult('control_out.inp', 'Output of ellipsometric parameters',1,'no', 'F', 0);
&set_parameter_mult('control_out.inp', 'Fluxes for path representation',   1, 'no', 'F', 0);
&set_parameter_mult('control_out.inp', 'Output of surface albedo',         1, 'no', 'F', 0);
&set_parameter_mult('control_out.inp', 'Transform to reflection function?',1, 'f', 'F', 0);
&set_parameter_mult('control_out.inp', 'Write local optical parameters',   1, 'f', 'F', 0);
&set_parameter_mult('control_out.inp', 'Intensity representation in output file', 
		    1, 'dynamic', 'F', 0); 
&set_parameter_mult('control_out.inp', 'Intensity or Stokes vector output format', 
		    1, 'default', 'T', 0); 
system("mv 'control_out.inp' $name");
#
# -----------------------------------------------------------------------------------
#  Set "control_ray.inp"
$file="$prog/'control_ray.inp'";
$name="$dir/'control_ray.inp'";
system("cp $file 'control_ray.inp'");
&set_parameter_mult('control_ray.inp','Rayleigh scattering scaling', 1, 'f 0.1', 'F', 0); 
&set_parameter_mult('control_ray.inp','Rayleigh optical thickness', 1, 't  0.1', 'F', 0); 
&set_parameter_mult('control_ray.inp','Number of wavelength and wavelength grid', 
		    1, '1', 'F', 0); 
&set_parameter_mult('control_ray.inp','Number of wavelength and wavelength grid', 
		    1, '500', 'F', 1); 
&set_parameter_mult('control_ray.inp','Rayleigh scattering index', 1, '4', 'F', 0); 
&set_parameter_mult('control_ray.inp','King factor', 1, 'constant', 'T', 0); 
&set_parameter_mult('control_ray.inp','Rayleigh depolarisation value', 1, '0.03', 'F', 0); 
system("mv 'control_ray.inp' $name");
#
# -----------------------------------------------------------------------------------
#  Set "control_geom.inp"
$file="$prog/'control_geom.inp'";
$name="$dir/'control_geom.inp'";
system("cp $file 'control_geom.inp'");
#     Specific settings
#&set_parameter_mult('control_geom.inp','The number of solar zenith angles', 1,'1'  ,'F',0);
&set_parameter_mult('control_geom.inp', 'Solar zenith angles',              1,'50.','F',0);
#
#&set_parameter_mult('control_geom.inp', 'The number of viewing angles', 1, '81', 'F', 0);
@inv = (
    '80.',  '79.',  '78.',  '77.',   '76.',   '75.',   '74.',   '73.', 
    '72.',  '71.',  '70.',  '69.',   '68.',   '67.',   '66.',   '65.', 
    '64.',  '63.',  '62.',  '61.',   '60.',   '59.',   '58.',   '57.', 
    '56.',  '55.',  '54.',  '53.',   '52.',   '51.',   '50.',   '49.', 
    '48.',  '47.',  '46.',  '45.',   '44.',   '43.',   '42.',   '41.', 
    '40.',  '39.',  '38.',  '37.',   '36.',   '35.',   '34.',   '33.', 
    '32.',  '31.',  '30.',  '29.',   '28.',   '27.',   '26.',   '25.', 
    '24.',  '23.',  '22.',  '21.',   '20.',   '19.',   '18.',   '17.', 
    '16.',  '15.',  '14.',  '13.',   '12.',   '11.',   '10.',    '9.', 
    '8.',   '7.',   '6.',   '5.',    '4.',    '3.',    '2.',     '1.',  '0.');
$ii = 1;
foreach $entry (@inv){
    &set_parameter_mult('control_geom.inp', 'Viewing angles', $ii, $entry, 'F', 0); 
    ++$ii;
}
#&set_parameter_mult('control_geom.inp', 'The number of azimuth angles', 1, '2', 'F', 0);
@inv = ('0.0', '180.0');
$ii = 1;
foreach $entry (@inv){
    &set_parameter_mult('control_geom.inp', 'Azimuth angles', $ii, $entry, 'F', 0); 
    ++$ii;
}
#     General settings
&set_parameter_mult('control_geom.inp','Position of the instrument', 1, 'toa', 'F', 0); 
&set_parameter_mult('control_geom.inp','Position to define geometry', 1, 'inst', 'F', 0);
#&set_parameter_mult('control_geom.inp','Viewing direction',          1, 'dn',  'F', 0);
&set_parameter_mult('control_geom.inp','Angle selection mode',       1, 'all', 'F', 0); 
&set_parameter_mult('control_geom.inp', 'Type of LOS definition',    1, 'va', 'F', 0);
system("mv 'control_geom.inp' $name");
#
# -----------------------------------------------------------------------------------
#  Copy "xsections.inp", 'control_aer.inp', 'man_aer.inp', which will be used
#                       without adjustment
$file="$prog/'xsections.inp'";
system("cp $file $dir/'xsections.inp'");
#
$file="$prog/'control_aer.inp'";
system("cp $file $dir/'control_aer.inp'");
#
$file="$prog/'man_aer.inp'";
system("cp $file $dir/'man_aer.inp'");
#
# -----------------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe $dir") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-up.dat'");
#
# ------------ Setting in "control_geom.inp" for downward radiation -----------------
#  Set "control_geom.inp"
$file="$dir/'control_geom.inp'";
$name="$dir/'control_geom.inp'";
system("cp $file 'control_geom.inp'");
&set_parameter_mult('control_geom.inp', 'Position of the instrument', 1, 'boa', 'F', 0);
@inv = (
    '100.',  '101.',  '102.',  '103.',   '104.',   '105.',   '106.',   '107.', 
    '108.',  '109.',  '110.',  '111.',   '112.',   '113.',   '114.',   '115.', 
    '116.',  '117.',  '118.',  '119.',   '120.',   '121.',   '122.',   '123.', 
    '124.',  '125.',  '126.',  '127.',   '128.',   '129.',   '130.',   '131.', 
    '132.',  '133.',  '134.',  '135.',   '136.',   '137.',   '138.',   '139.', 
    '140.',  '141.',  '142.',  '143.',   '144.',   '145.',   '146.',   '147.', 
    '148.',  '149.',  '150.',  '151.',   '152.',   '153.',   '154.',   '155.', 
    '156.',  '157.',  '158.',  '159.',   '160.',   '161.',   '162.',   '163.', 
    '164.',  '165.',  '166.',  '167.',   '168.',   '169.',   '170.',   '171.', 
    '172.',  '173.',  '174.',  '175.',   '176.',   '177.',   '178.',   '179.',  '180.');
#&set_parameter_mult('control_geom.inp', 'Viewing direction', 1, 'up', 'F', 0);
$ii = 1;
foreach $entry (@inv){
    &set_parameter_mult('control_geom.inp', 'Viewing angles', $ii, $entry, 'F', 0); 
    ++$ii;
}
system("mv 'control_geom.inp' $name");
#       Perform SCIATRAN calculation for downward
# -----------------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe $dir") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-dn.dat'");
system("$dir/'check_out.exe'");

exit 0;
#
#   ************  Auxiliary subroutines **************
#
sub set_parameter_mult {
     my ($inp_file, $parameter, $num, $value, $quoted, $skip) = @_;
     open (control_file, "<$inp_file");
     my @contents=<control_file>;
     close (control_file);
     my $ii = search_parameter($parameter, @contents) + $skip;
     @entries = split(',', $contents[$ii]);
     if($quoted eq 'T') {${new_entry} = "\'$value\'"}
     else{${new_entry} = "$value"};
     $entries[$num - 1] = ${new_entry};
     $contents[$ii] = '';
     foreach $element (@entries) {
     chomp ($element);
     $contents[$ii] .= "$element,"
     }
     chop ($contents[$ii]) ; # remove last comma
     $contents[$ii] .= "\n" ; # add line break
     open (control_file, ">$inp_file");
     foreach $line (@contents){
     print (control_file $line);
     }
     close (control_file);
 return
}
sub search_parameter {
     my ($parameter, @contents) = @_;
     my $ii = 0;
     my $line ;
   search_loop:
     foreach $line (@contents) {
     if($line =~ /\A\s*\#/) {
         ++$ii;
         next search_loop;
     }
     if($line =~ /$parameter/) {
         last search_loop};
     ++$ii ;
     }
     my $nn = $ii + 1;
     return ($nn);
}
