#!/usr/bin/perl
use lib ("./");
use MainIPRT;

$prog=$ARGV[0];
$n_exe=$ARGV[1];
$dir = './A6';
# -----------------------------------------------------------------------
$name="$dir/my_init.inp";

@MainArr = MainInit();
@AddArr = InitA();

#     Specific settings
push @LocArr, 'Number of streams';
push @LocArr, "32 \n";
push @LocArr, 'Number of Legendre moments';
push @LocArr, "64 \n";
push @LocArr, 'RTM_TYPE';
push @LocArr, "pp_scat \n";
push @LocArr, 'Surface reflection type';
push @LocArr, "brdf \n";
#     BRDF settings
push @LocArr, 'Surface type';
push @LocArr, "ocean \n";
push @LocArr, 'Exact BRDF for diffuse radiation';
push @LocArr, "f \n";
push @LocArr, 'Specular reflection';
push @LocArr, "f \n";
push @LocArr, 'Transmission matrix water->air and air->water';
push @LocArr, "\'Rho_water_air.dat\' ";
push @LocArr, "\'Rho_air_water.dat\' \n";
push @LocArr, 'Whitecaps     Glint     Water leaving';
push @LocArr, "off        vector       off \n";
push @LocArr, 'Seawater general properties';
push @LocArr, "20.0   37.0   0.193   0.045   0.02   Morel   2.0   36.75 \n";
push @LocArr, 'Refractive index input type (BRDF)';
push @LocArr, "const \n";
push @LocArr, 'Refractive index of water (BRDF)';
push @LocArr, "1.33    0.0 \n";
push @LocArr, 'Refractive index file name';
push @LocArr, "\'water.dat\' \n";
push @LocArr, 'Surface slope PDF';
push @LocArr, "Gauss \n";
push @LocArr, 'Mean square slope';
push @LocArr, "3.d-03   5.12d-03    0.d-00   3.16d-03    3.d-03   1.92d-03 \n";
push @LocArr, 'Shadowing effects?';
push @LocArr, "yes \n";
push @LocArr, 'Replace cosine';
push @LocArr, "f \n";
push @LocArr, 'BRDF output control';
push @LocArr, "f \n";

#     Specific geometry settings
push @LocArr, 'Solar zenith angles';
push @LocArr, "45 \n";
push @LocArr, 'Azimuth angles';
push @LocArr, "0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0, 95.0, 100.0, 105.0, 110.0, 115.0, 120.0, 125.0, 130.0, 135.0, 140.0, 145.0, 150.0, 155.0, 160.0, 165.0, 170.0, 175.0, 180.0 \n";


#
# ------------ Setting  for upward radiation -----------------
push @ViewDir, 'Position of the instrument';
push @ViewDir, "toa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "80., 75., 70., 65., 60., 55., 50., 45., 40., 35., 30., 25., 20., 15., 10., 5., 0. \n";

push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

# -----------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-up.dat'");

#
# ------------ Settings  for downward radiation -----------------
undef @ViewDir;
push @ViewDir, 'Position of the instrument';
push @ViewDir, "boa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "100., 105., 110., 115., 120., 125., 130., 135., 140., 145., 150., 155., 160., 165., 170., 175., 180. \n";

# ------------ Writing my_init.inp -----------------
undef @contents;
push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

#       Perform SCIATRAN calculation for downward radiation
# ----------------------------------------------------------
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-dn.dat'");
system("$dir/'check_out.exe'");

exit 0;
