#!/usr/bin/perl
use lib ("./");
use MainIPRT;

$prog=$ARGV[0];
$n_exe=$ARGV[1];
$dir = './B3';
# ----------------------------------------------------------------------------
$name="$dir/my_init.inp";

@MainArr = MainInit();
@AddArr = InitB();

#     Specific settings
push @LocArr, 'Number of streams';
push @LocArr, "64 \n";
push @LocArr, 'Number of Legendre moments';
push @LocArr, "128 \n";
#     Specific geometry settings
push @LocArr, 'Solar zenith angles';
push @LocArr, "30 \n";
push @LocArr, 'Azimuth angles';
push @LocArr, "0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0, 95.0, 100.0, 105.0, 110.0, 115.0, 120.0, 125.0, 130.0, 135.0, 140.0, 145.0, 150.0, 155.0, 160.0, 165.0, 170.0, 175.0, 180.0 \n";

#     ali settings
push @LocArr, 'Logical flag';
push @LocArr, "t   t   t   f \n";
push @LocArr, 'Path';
push @LocArr, "\'./B3/\' \n";
push @LocArr, 'Altitude and wavelength grid';
push @LocArr, "\'z_iprt.dat\' \'wl_iprt.dat\' \n";
push @LocArr, 'Rayleigh';
push @LocArr, "\'tau_rayleigh_350.dat\' \'ray_ec.dat\' \n";
push @LocArr, 'Absorber filename';
push @LocArr, "\'tau_molabs_350.dat\' \n";
push @LocArr, 'Aerosol';
push @LocArr, "\'tau_aerosol-sca.dat\' \'tau_aerosol-abs.dat\' \'aer_ec.dat\'\n";

#     aerosol settings
push @LocArr, 'Aerosol parameterization type';
push @LocArr, "mn \n";
push @LocArr, 'Top of aerosol layers';
push @LocArr, "\'from sea level\' \n";
push @LocArr, 'Add level at boudary layer top';
push @LocArr, "f \n";
push @LocArr, 'Aerosol scaling parameter';
push @LocArr, "1.0 \n";
push @LocArr, 'Aerosol scaling factor';
push @LocArr, "f \n";
push @LocArr, 'Aerosol OT at reference wavelength';
push @LocArr, "f \n";
push @LocArr, 'Additional aerosol OT';
push @LocArr, "0 \n";
push @LocArr, 'Use ECSTRA model';
push @LocArr, "f \n";
push @LocArr, 'Replace aerosol extinction';
push @LocArr, "f \n";
push @LocArr, 'Aerosol scattering matrix output';
push @LocArr, "f \n";
push @LocArr, 'Output of aerosol OT';
push @LocArr, "0 \n";

open (ManAerFile, "<$dir/man_aer.inp");
@ManAer=<ManAerFile>;
close (ManAerFile);

#
# ------------ Setting  for upward radiation -----------------
push @ViewDir, 'Position of the instrument';
push @ViewDir, "toa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "85., 80., 75., 70., 65., 60., 55., 50., 45., 40., 35., 30., 25., 20., 15., 10., 5., 0. \n";

push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
foreach $line (@ManAer){
    print (my_init "$line");
}
close (my_init);

# -----------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-up.dat'");

#
# ------------ Settings  for downward radiation -----------------
undef @ViewDir;
push @ViewDir, 'Position of the instrument';
push @ViewDir, "boa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "180. 175., 170., 165., 160., 155., 150., 145., 140., 135., 130., 125., 120., 115., 110., 105., 100., 95. \n";

# ------------ Writing my_init.inp -----------------
undef @contents;
push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
foreach $line (@ManAer){
    print (my_init "$line");
}
close (my_init);

#       Perform SCIATRAN calculation for downward radiation
# ----------------------------------------------------------
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-dn.dat'");
system("$dir/'check_out.exe'");

exit 0;
