#!/usr/bin/perl
use lib ("./");
use MainIPRT;

$prog=$ARGV[0];
$n_exe=$ARGV[1];
$dir = './B4';
# ----------------------------------------------------------------------------
#  Test topic - Cloud above ocean surface
$name="$dir/my_init.inp";

@MainArr = MainInit();
@AddArr = InitB();

#     Specific settings
push @LocArr, 'Number of streams';
push @LocArr, "64 \n";
push @LocArr, 'Number of Legendre moments';
push @LocArr, "128 \n";
push @LocArr, 'Surface reflection type';
push @LocArr, "brdf \n";
#     Specific geometry settings
push @LocArr, 'Solar zenith angles';
push @LocArr, "60 \n";
push @LocArr, 'Azimuth angles';
push @LocArr, "0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0, 95.0, 100.0, 105.0, 110.0, 115.0, 120.0, 125.0, 130.0, 135.0, 140.0, 145.0, 150.0, 155.0, 160.0, 165.0, 170.0, 175.0, 180.0 \n";

#     ali settings
push @LocArr, 'Logical flag';
push @LocArr, "f   t   f   t \n";
push @LocArr, 'Path';
push @LocArr, "\'./B4/\' \n";
push @LocArr, 'Altitude and wavelength grid';
push @LocArr, "\'z_iprt.dat\' \'wl_iprt.dat\' \n";
push @LocArr, 'Rayleigh';
push @LocArr, "\'tau_rayleigh_800.dat\' \'ray_ec.dat\' \n";
push @LocArr, 'Absorber filename';
push @LocArr, "\'tau_molabs_350.dat\' \n";
push @LocArr, 'Cloud';
push @LocArr, "\'coef_cld-sca.dat\' \'coef_cld-abs.dat\' \'cld_ec.dat\'\n";

#     BRDF settings
push @LocArr, 'Surface type';
push @LocArr, "ocean \n";
push @LocArr, 'Exact BRDF for diffuse radiation';
push @LocArr, "f \n";
push @LocArr, 'Specular reflection';
push @LocArr, "f \n";
push @LocArr, 'Transmission matrix water->air and air->water';
push @LocArr, "\'Rho_water_air.dat\' ";
push @LocArr, "\'Rho_air_water.dat\' \n";
push @LocArr, 'Whitecaps     Glint     Water leaving';
push @LocArr, "off        vector       off \n";
push @LocArr, 'Seawater general properties';
push @LocArr, "20.0   37.0   0.193   0.045   0.02   Morel   2.0   36.75 \n";
push @LocArr, 'Refractive index input type (BRDF)';
push @LocArr, "const \n";
push @LocArr, 'Refractive index of water (BRDF)';
push @LocArr, "1.33    0.0 \n";
push @LocArr, 'Refractive index file name';
push @LocArr, "\'water.dat\' \n";
push @LocArr, 'Surface slope PDF';
push @LocArr, "Gauss \n";
push @LocArr, 'Mean square slope';
push @LocArr, "3.d-03   5.12d-03    0.d-00   3.16d-03    3.d-03   1.92d-03 \n";
push @LocArr, 'Shadowing effects?';
push @LocArr, "yes \n";
push @LocArr, 'Replace cosine';
push @LocArr, "f \n";
push @LocArr, 'BRDF output control';
push @LocArr, "f \n";

#   Cloud settings
push @LocArr, 'Path to cloud data bases';
push @LocArr, "\'./\' \n";
push @LocArr, 'Refractive index of water and ice';
push @LocArr, "\'Water_refr_idx.dat\' \'Waren-Brandt_2008.dat\' \n";
push @LocArr, 'Number of cloud layers';
push @LocArr, "1 \n";
push @LocArr, 'Cloud layers are vertically inhomogeneous';
push @LocArr, "no \n";
push @LocArr, 'Use constant phase function within cloud layer';
push @LocArr, "t \n";
push @LocArr, 'Cloud particle geometrical dimension';
push @LocArr, "12. 50.   100. 100. \n";
push @LocArr, 'Thermodynamic state';
push @LocArr, "water \n";
push @LocArr, 'Scattering and absorption coefficients';
push @LocArr, "analytically \n";
push @LocArr, 'Type of input integral parameter';
push @LocArr, "TAU \n";
push @LocArr, 'Input integral parameter';
push @LocArr, "5.0      42.477     0.1     10.0 \n";
push @LocArr, 'Phase function of cloud layers';
push @LocArr, "user \n";
push @LocArr, 'Expansion coefficients input file';
push @LocArr, "\'Legandre_6.dat\' \n";
push @LocArr, 'Delta-M or Delta-Fit';
push @LocArr, "D-M \n";
push @LocArr, 'Delta-m truncation for cloud layers';
push @LocArr, "127 \n";
push @LocArr, 'Additional absorber within cloud';
push @LocArr, "f \n";
push @LocArr, 'Phase functions output';
push @LocArr, "f \n";
push @LocArr, 'Weighting functions: cloud parameters';
push @LocArr, "none \n";

#
# ------------ Setting  for upward radiation -----------------
push @ViewDir, 'Position of the instrument';
push @ViewDir, "toa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "85., 80., 75., 70., 65., 60., 55., 50., 45., 40., 35., 30., 25., 20., 15., 10., 5., 0. \n";

push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

# -----------------------------------------------------------------------------
#       Perform SCIATRAN calculation for upward radiation
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-up.dat'");

#
# ------------ Settings  for downward radiation -----------------
undef @ViewDir;
push @ViewDir, 'Position of the instrument';
push @ViewDir, "boa \n";
push @ViewDir, 'Viewing angles';
push @ViewDir, "180. 175., 170., 165., 160., 155., 150., 145., 140., 135., 130., 125., 120., 115., 110., 105., 100., 95. \n";

# ------------ Writing my_init.inp -----------------
undef @contents;
push @contents, @ViewDir;
push @contents, @LocArr;
push @contents, @AddArr;
push @contents, @MainArr;
open (my_init, ">$name");
foreach $line (@contents){
    print (my_init "$line \n");
}
close (my_init);

#       Perform SCIATRAN calculation for downward radiation
# ----------------------------------------------------------
system("$prog/$n_exe DIR=$dir CID=$prog ") ==0 or die;
system("cp $dir/'DATA_OUT/intensity.dat' $dir/'DATA_OUT/intensity-dn.dat'");
system("$dir/'check_out.exe'");

exit 0;
